package worldcontrolteam.worldcontrol.crossmod.extremereactors.reactormonitor;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import worldcontrolteam.worldcontrol.crossmod.extremereactors.ExtremeReactorsModule;
import worldcontrolteam.worldcontrol.items.ItemBaseKit;
import worldcontrolteam.worldcontrol.utils.WCUtility;

/**
 * Created by dmf444 on 10/16/2017. Code originally written for World-Control.
 */
public class ExtremeReactorsKit extends ItemBaseKit {

    public ExtremeReactorsKit() {
        super("er_kit");
    }

    @Override
    public Item getCardType() {
        return ExtremeReactorsModule.REACTOR_CARD;
    }

    @Override
    public boolean canReturnCard(ItemStack stack, World world, BlockPos pos) {
        if (world.func_180495_p(pos).func_177230_c() == ExtremeReactorsModule.REACTOR_MONITOR) {
            WCUtility.getTileEntity(world, pos, TileReactorMonitor.class).ifPresent(TileReactorMonitor::startFetching);
            return true;
        }
        return false;
    }
}
