package worldcontrolteam.worldcontrol.inventory.container;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import worldcontrolteam.worldcontrol.inventory.SlotFilterItemHandler;
import worldcontrolteam.worldcontrol.tileentity.TileEntityBaseAverageCounter;

import javax.annotation.Nonnull;

public class ContainerAverageCounter extends Container {

    public TileEntityBaseAverageCounter averageCounter;
    private EntityPlayer player;
    private double lastAverage = -1;

    public ContainerAverageCounter(EntityPlayer player, TileEntityBaseAverageCounter averageCounter) {
        super();

        this.averageCounter = averageCounter;
        this.player = player;

        //transformer upgrades
        func_75146_a(new SlotFilterItemHandler(averageCounter.inventory, 0, 8, 18));

        //inventory
        for (int i = 0; i < 3; i++)
            for (int k = 0; k < 9; k++)
                func_75146_a(new Slot(player.field_71071_by, k + i * 9 + 9, 8 + k * 18, 84 + i * 18));

        for (int j = 0; j < 9; j++)
            func_75146_a(new Slot(player.field_71071_by, j, 8 + j * 18, 142));
    }

    @Override
    public boolean func_75145_c(EntityPlayer playerIn) {
        return true;
    }

    @Override
    @Nonnull
    public ItemStack func_82846_b(EntityPlayer p, int slotId) {
        Slot slot = this.field_75151_b.get(slotId);
        if (slot != null) {
            ItemStack items = slot.func_75211_c();
            if (!items.func_190926_b()) {
                int initialCount = items.func_190916_E();
                if (slotId < averageCounter.inventory.getSlots())//moving from counter to inventory
                {
                    func_75135_a(items, averageCounter.inventory.getSlots(), field_75151_b.size(), false);
                    if (items.func_190916_E() == 0)
                        slot.func_75215_d(ItemStack.field_190927_a);
                    else {
                        slot.func_75218_e();
                        if (initialCount != items.func_190916_E())
                            return items;
                    }
                } else for (int i = 0; i < averageCounter.inventory.getSlots(); i++) {
                    if (!averageCounter.isItemValid(i, items))
                        continue;
                    ItemStack targetStack = averageCounter.inventory.getStackInSlot(i);
                    if (targetStack.func_190926_b()) {
                        Slot targetSlot = this.field_75151_b.get(i);
                        targetSlot.func_75215_d(items);
                        slot.func_75215_d(ItemStack.field_190927_a);
                        break;
                    } else if (items.func_77985_e() && items.func_77969_a(targetStack)) {
                        func_75135_a(items, i, i + 1, false);
                        if (items.func_190916_E() == 0)
                            slot.func_75215_d(ItemStack.field_190927_a);
                        else {
                            slot.func_75218_e();
                            if (initialCount != items.func_190916_E())
                                return items;
                        }
                        break;
                    }

                }
            }
        }
        return ItemStack.field_190927_a;
    }

}
