package worldcontrolteam.worldcontrol.network.messages;

import io.netty.buffer.ByteBuf;
import net.minecraft.client.Minecraft;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.common.network.ByteBufUtils;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import worldcontrolteam.worldcontrol.api.card.predefs.IProviderCard;
import worldcontrolteam.worldcontrol.init.WCContent;
import worldcontrolteam.worldcontrol.inventory.InventoryItem;

public class PacketClientRemotePanel implements IMessage {

    private ItemStack stack;

    public PacketClientRemotePanel() {
    }

    public PacketClientRemotePanel(ItemStack stack) {
        this.stack = stack;
    }

    @Override
    public void fromBytes(ByteBuf buf) {
        this.stack = ByteBufUtils.readItemStack(buf);
    }

    @Override
    public void toBytes(ByteBuf buf) {
        ByteBufUtils.writeItemStack(buf, stack);
    }

    public static class Handler implements IMessageHandler<PacketClientRemotePanel, IMessage> {

        @Override
        @SideOnly(Side.CLIENT)
        public IMessage onMessage(PacketClientRemotePanel message, MessageContext ctx) {
            EntityPlayer player = Minecraft.func_71410_x().field_71439_g;
            if (!player.func_184614_ca().func_190926_b())
                if (player.func_184614_ca().func_77973_b() == WCContent.REMOTE_PANEL) {
                    // ItemRemoteMonitor remote = (ItemRemoteMonitor)
                    // player.getHeldItem().getItem();
                    InventoryItem itemInv = new InventoryItem(player.func_184614_ca());
                    // NCLog.fatal(itemInv.getStackInSlot(0));
                    if (itemInv.func_70301_a(0).func_190926_b() || !(itemInv.func_70301_a(0).func_77973_b() instanceof IProviderCard))
                        return null;
                    if (message.stack.func_77942_o()) {
                        ItemStack stackz = itemInv.func_70301_a(0).func_77946_l();
                        stackz.func_77982_d(message.stack.func_77978_p());
                        itemInv.func_70299_a(0, stackz);

                    }
                    // NCLog.fatal("CLIENT RECIEVE: " +
                    // ItemStackUtils.getTagCompound(itemInv.getStackInSlot(0)).getInteger("energyL"));
                }
            return null;
        }
    }
}
