package worldcontrolteam.worldcontrol.blocks;


import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemDye;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import worldcontrolteam.worldcontrol.tileentity.TileEntityHowlerAlarm;
import worldcontrolteam.worldcontrol.utils.GuiLib;
import worldcontrolteam.worldcontrol.utils.WCUtility;

public class BlockHowlerAlarm extends BlockIndustrialAlarm {

    public BlockHowlerAlarm() {
        super("howler_alarm");
    }

    @Override
    public TileEntity createTile(World world, int meta) {
        return new TileEntityHowlerAlarm();
    }

    @Override
    public boolean hasGUI() {
        return true;
    }

    @Override
    public int guiID() {
        return GuiLib.HOWLER_ALARM;
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand, EnumFacing side, float hitX, float hitY, float hitZ) {
        if (player.func_184586_b(hand) != ItemStack.field_190927_a) {
            if (player.func_184586_b(hand).func_77973_b() instanceof ItemDye) {
                WCUtility.getTileEntity(world, pos, TileEntityHowlerAlarm.class).ifPresent(tile -> tile.setColor(ItemDye.field_150922_c[player.func_184586_b(hand).func_77960_j()]));
                world.func_175704_b(pos, pos);
                return true;
            }
        }
        return super.func_180639_a(world, pos, state, player, hand, side, hitX, hitY, hitZ);
    }

}
