package worldcontrolteam.worldcontrol.client.gui;


import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.resources.I18n;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.client.gui.features.HowlerAlarmSlider;
import worldcontrolteam.worldcontrol.container.ContainerEmpty;
import worldcontrolteam.worldcontrol.tileentity.TileEntityHowlerAlarm;

@SideOnly(Side.CLIENT)
public class GuiIndustrialAlarm extends GuiContainer {

    private static final String TEXTURE_FILE = "worldcontrol:textures/gui/gui_industrial_alarm.png";
    private static final ResourceLocation TEXTURE_LOCATION = new ResourceLocation(TEXTURE_FILE);

    private TileEntityHowlerAlarm alarm;
    private HowlerAlarmSlider slider;
    private String name;

    public GuiIndustrialAlarm(TileEntityHowlerAlarm alarm) {
        super(new ContainerEmpty(alarm));
        field_146999_f = 131;
        field_147000_g = 64;
        this.alarm = alarm;
        name = I18n.func_135052_a("tile.worldcontrol.industrial_alarm.name");
    }

    @SuppressWarnings("unchecked")
    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        field_147003_i = (this.field_146294_l - field_146999_f) / 2;
        field_147009_r = (this.field_146295_m - field_147000_g) / 2;
        field_146292_n.clear();
        slider = new HowlerAlarmSlider(3, field_147003_i + 12, field_147009_r + 33, "msg.worldcontrol.HowlerAlarmSoundRange", alarm);
        field_146292_n.add(slider);
    }

    @Override
    public boolean func_73868_f() {
        return false;
    }

    @Override
    protected void func_146979_b(int par1, int par2) {
        field_146289_q.func_78276_b(name, (field_146999_f - field_146289_q.func_78256_a(name)) / 2, 6, 0x404040);
    }

    @Override
    protected void func_146286_b(int mouseX, int mouseY, int which) {
        super.func_146286_b(mouseX, mouseY, which);
        if ((which == 0 || which == 1) && slider.dragging) {
            slider.func_146118_a(mouseX, mouseY);
        }
    }

    @Override
    protected void func_146976_a(float var1, int var2, int var3) {
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        field_146297_k.field_71446_o.func_110577_a(TEXTURE_LOCATION);
        int left = (field_146294_l - field_146999_f) / 2;
        int top = (field_146295_m - field_147000_g) / 2;
        func_73729_b(left, top, 0, 0, field_146999_f, field_147000_g);
    }
}

