package worldcontrolteam.worldcontrol.inventory;

import net.minecraft.item.ItemStack;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.SlotItemHandler;

import javax.annotation.Nonnull;

public class SlotFilterItemHandler extends SlotItemHandler {

    private final int slotIndex;

    public SlotFilterItemHandler(IItemHandler itemHandler, int index, int xPosition, int yPosition) {
        super(itemHandler, index, xPosition, yPosition);
        this.slotIndex = index;
    }

    @Override
    public boolean func_75214_a(ItemStack itemStack) {
        if (field_75224_c instanceof ISlotItemFilter)
            return ((ISlotItemFilter) field_75224_c).isItemValid(slotIndex, itemStack);
        return super.func_75214_a(itemStack);
    }
}
